<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'nologin');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.log.php');

// PARAMETERS
if( empty($_SERVER['HTTP_USER_AGENT']) ) {
    if( empty($_SERVER['argv'][1]) ) die("Bad timeout");
    $stimeout = intval($_SERVER['argv'][1]);
} else {
    if( _safe_var($_GET['key'])!=$DBCONF['key_code'] ) die("Bad key word parameter");
    if( empty($_GET['timeout']) ) die("Bad timeout");
    $stimeout = intval($_GET['timeout']);
    if( $CONF['demo'] ) { $stimeout = 60; echo "Demo mode. Request timeout = 60 sec"; }
}

// INIT
set_time_limit(0);
ignore_user_abort(1);
ob_implicit_flush();

echo "<h2>Proxy recheck</h2><pre>\r\n";
$stime = time();
slog('Started (Recheck)', SLOG_SYS);

// CURL
if( !function_exists('curl_exec') ) slog('cURL library is not found', SLOG_ERR, 1);
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $DBCONF['info_url']);
curl_setopt($ch, CURLOPT_TIMEOUT, $DBCONF['request_timeout']);
curl_setopt($ch, CURLOPT_USERAGENT, $CONF['user_agent']);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

// RESET "STOP" PARAMETER
mysql_query("UPDATE `".$CONF['tbl_conf']."` SET value='0' WHERE name='stop'") or die(mysql_error());

//
// START RECHECK
//
do {
    // CHECK FOR "STOP" PARAMETER
    $res = mysql_query("SELECT value as stop FROM `".$CONF['tbl_conf']."` WHERE name='stop'") or die(mysql_error());
    if(mysql_result($res,0)) { slog("Terminated by user",SLOG_SYS); break; }
    mysql_free_result($res);

    // GET PROXY
    $res = mysql_query("SELECT * FROM `".$CONF['tbl_proxy']."` WHERE `work` AND UNIX_TIMESTAMP(`date`) <= (UNIX_TIMESTAMP()-".intval($DBCONF['check_interval']).") ORDER BY `date` LIMIT 0,1") or die(mysql_error());
    if(!mysql_num_rows($res)) { slog("Nothing to check"); break; }
    $proxy = mysql_fetch_assoc($res);

    // CHECK PROXY FOR "WORK" PARAM ONLY
    curl_setopt($ch, CURLOPT_PROXY, $proxy['host'].':'.$proxy['port'] );
    $content = curl_exec($ch);
    if( stristr($content, "REQUEST_INFO_PAGE_4896485_CODE") ) {
    	slog("Worked [".$proxy['host'].':'.$proxy['port']."]", SLOG_OK);
    	mysql_query("UPDATE `".$CONF['tbl_proxy']."` SET date=NOW() WHERE id=".intval($proxy['id'])) or die(mysql_error());
    } else {
        slog("Unworked [".$proxy['host'].':'.$proxy['port']."] ".curl_error($ch));
        mysql_query("DELETE FROM `".$CONF['tbl_proxy']."` WHERE id=".intval($proxy['id'])) or die(mysql_error());
    }
    mysql_free_result($res);
}
while( (time()-$stime) < $stimeout or $stimeout==0 );

// TERMINATE
curl_close($ch);
slog("Terminated (Recheck): ".(time()-$stime)." sec", SLOG_SYS);
?>