<?php
/**
* Log functions
* @author Igor Shatokhin (icq:137-908-479)
* @link igshat@gawab.com
*/

define('SLOG_MES', ">");
define('SLOG_SYS', "$");
define('SLOG_OK', "+");
define('SLOG_ERR', "-");
define('SLOG_WARN', "!");

/**
* Output log-message with type and date
* @param string $mes
* @param char $type
* @param bool $die
* @return string $mes
*/
function slog($mes, $type=SLOG_MES, $die=false) {
    echo "[".date("d/H:i:s")." ".$type."] ".$mes."\r\n";
    if($die) die;
    return $mes;
}


?>