<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'nologin');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.log.php');
include_once(dirname(__FILE__).'/../lib/func.files.php');
include_once(dirname(__FILE__).'/../lib/func.get_proxies.php');

// PARAMETERS
if( !empty($_SERVER['HTTP_USER_AGENT']) ) {
    if( _safe_var($_GET['key'])!=$DBCONF['key_code'] ) die("Bad key word parameter");
}

// INIT
echo "<h2>Proxy list export</h2><pre>\r\n";
set_time_limit(0);
ignore_user_abort(1);
ob_implicit_flush();
$stime = time();
$pid = getmypid();
slog('Started (Proxy Exporter)', SLOG_SYS);

// GET EXPORT TABLE
$exp_res = mysql_query("SELECT * FROM `".$CONF['tbl_export']."` ORDER BY 'type'") or die(mysql_error());
if(!mysql_num_rows($exp_res)) slog("Export table is empty");

//
// START EXPORT
//
while( ($exp=mysql_fetch_assoc($exp_res))!=false ) {
    
	// GET LIST
    $limit = $exp['f_limit'] ? "LIMIT 0,".intval($exp['f_limit']) : '';
    $params = array(
        'work'=>$exp['f_work'],
        'post'=>$exp['f_post'],
        'ref'=>$exp['f_ref'],
        'cookies'=>$exp['f_cookies'],
        'anon'=>$exp['f_anon'],
        'port'=>$exp['f_port'],
        'country'=>$exp['f_country'],
        'contime'=>$exp['f_contime'],
        'time'=>$exp['f_time'],
        'fresh'=>$exp['f_fresh']  );
    $arr = get_proxies($db, $CONF['tbl_proxy'], $params, $limit);
    $list = "";
    foreach(_safe_array($arr) as $v) $list .= $v['host'].':'.$v['port']."\r\n";

    //
    // EXPORT LIST
    //
    $sql_err_inc = "UPDATE `".$CONF['tbl_export']."` SET errors = errors+1 WHERE id=".intval($exp['id']);
    switch($exp['t_type']) {
        //
        // SAVE TO FILE
        //
        case 'file':
            if( @file_save($exp['t_path'],$list)!==false ) slog("Exported to file (id: ".$exp['id'].")", SLOG_OK);
            else {
                slog("Cannot write file (id: ".$exp['id'].")", SLOG_ERR);
                mysql_query($sql_err_inc) or die(mysql_error());
            }
            break;

        //
        // SEND TO MAIL
        //
        case 'mail':
            if( @mail($exp['t_mail'],$CONF['exp_mail_subj'],$list,$CONF['exp_mail_headers']) ) slog("Sended to e-mail (id: ".$exp['id'].")", SLOG_OK);
            else {
                slog("Cannot send mail (id: ".$exp['id'].")", SLOG_ERR);
                mysql_query($sql_err_inc) or die(mysql_error());
            }
            break;

        //
        // UPLOAD TO FTP-SERVER
        //
        case 'ftp':
            $tmp_file = realpath( dirname(__FILE__).'/../templates_c/' ).'/list.tmp';
            if( @file_save($tmp_file,$list)===false ) {
                slog("Cannot write temp file (check permissions): ".$tmp_file, SLOG_ERR);
                mysql_query($sql_err_inc) or die(mysql_error());
            }
            else {
                if( preg_match("|^(.+)\:(\d+)$|", $exp['t_serv'], $m) ) { $host=$m[1]; $port=$m[2]; }
                else { $host=$exp['t_serv']; $port=21; }

                $conn_id = @ftp_connect($host, $port, $CONF['request_timeout']);
                if( !$conn_id ) {
                    slog("Cannot connect to FTP-server (id: ".$exp['id'].")", SLOG_ERR);
                    mysql_query($sql_err_inc) or die(mysql_error());
                }
                else {
                    $login_result = @ftp_login($conn_id, $exp['t_user'], $exp['t_pass']);
                    if( !$login_result ) {
                        slog("Cannot login to FTP-server (id: ".$exp['id'].") User: ".$exp['t_user'], SLOG_ERR);
                        mysql_query($sql_err_inc) or die(mysql_error());
                    }
                    else {
                        if( ftp_put($conn_id, $exp['t_path'], $tmp_file, FTP_ASCII) ) slog("Uploaded to FTP-server (id: ".$exp['id'].")", SLOG_OK);
                        else {
                            slog("Cannot upload to FTP-server (id: ".$exp['id'].")", SLOG_ERR);
                            mysql_query($sql_err_inc) or die(mysql_error());
                        }
                    }
                    @ftp_close($conn_id);
                }
            }
            @unlink($tmp_file);
            break;
    }
}

slog("Terminated (Proxy Exporter): ".(time() - $stime)." sec", SLOG_SYS);
?>
