<?php

error_reporting(E_ALL);

// DIRECTORIES AND URLS
define('PROJECT_URL', '' );
define('SMARTY_DIR', dirname(__FILE__).'/../smarty/' );

// DATABASE
$CONF['db_name'] = 'proxy3';
$CONF['db_host'] = 'localhost';
$CONF['db_user'] = 'root';
$CONF['db_pass'] = 'alphakey';

// TABLES NAMES
$CONF['tbl_proxy'] = 'proxy';
$CONF['tbl_conf'] = 'proxy_conf';
$CONF['tbl_url'] = 'proxy_urls';
$CONF['tbl_export'] = 'proxy_export';
$CONF['tbl_country'] = 'proxy_countries';

// PHP PATH
$CONF['php_path'] = '/usr/local/bin/php';

// COMMANDS
//$CONF['ping_cmd'] = "ping -w1 [ip]";    // for Linux
$CONF['ping_cmd'] = "/sbin/ping -c4 -t1 [ip]";    // for FreeBSD

// GRABBER
$CONF['user_agent'] = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)';
$CONF['request_timeout'] = 30;

// host and port detach patterns
$CONF['reg_exp'] = array(
'#(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[\w\-\.]{2,50}\.\w{2,4})\:(\d{2,6})#i',
'#>\s*(?:&\w{2,6};)*\s*(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}|[\w\-\.]{2,50}\.\w{2,4})\s*<.{0,1000}?>\s*(\d{2,6})\s*(?:&\w{2,6};)*\s*<#s'
);

// CHECKER
$CONF['part_size'] = 10;

// EXPORT
$CONF['exp_mail_subj'] = "Proxy list from Proxy Checker";
$CONF['exp_mail_headers'] = "";

// OTHER
$CONF['demo'] = 0;
$CONF['login'] = 1;

?>