<?php
//****************************************************************************
// class.mysql.php
// MySQL database driver
//****************************************************************************
//   phpDatabase 2.1
//   Author: Maxim Poltarak  <maxx at e dash taller dot net>
//   Category: Databases
//****************************************************************************
// The lib is FREEWARE. This means you may use it anywhere you want, you may
// do anything with it. The Author mentioned above is NOT responsible for any
// consequences of using this library.
// If you don't agree with this, you MUST NOT USE the lib!
//****************************************************************************
// All improvings, feature requests, bug reports, etc. are gladly accepted.
//****************************************************************************
// Note: For best viewing of the code Tab size 4 is recommended
//****************************************************************************
// Updates:
// special edition for Proxy Searcher (2006-05-21)
//****************************************************************************
class cdatabase {
        var $db, $host, $user, $pass;   // connect parameters
        var $link;                      // link to opened connection
        var $connect;                   // selected DB

        function cdatabase($db, $host, $user, $pass) {
                $this->db = $db; $this->host = $host; $this->user = $user; $this->pass = $pass;
                if( $this->link = @mysql_connect($host,$user,$pass) )
                    $this->connect = @mysql_select_db($db, $this->link);
                else
                    $this->connect = false;
        }

        function is_connected() {
                return $this->connect;
        }

        function query($sql) {
                if(!$this->link) return 0;
                return mysql_query($sql, $this->link);
        }

        function affected_rows() {
                return mysql_affected_rows($this->link);
        }

        function num_rows($q) {
                return mysql_num_rows($q);
        }

        function fetch_array($q, $result_type=MYSQL_ASSOC) {
                return mysql_fetch_array($q, $result_type);
        }

        function fetch_object($q) {
                return mysql_fetch_object($q);
        }

        function data_seek($q, $n) {
                return mysql_data_seek($q, $n);
        }

        function free_result($q) {
                return mysql_free_result($q);
        }

        function insert_id() {
                return mysql_insert_id($this->link);
        }

        function error() {
                return mysql_error($this->link);
        }

        function errno() {
                return mysql_errno($this->link);
        }

        function error_die($msg='') {
                die(((empty($msg))?'':$msg.': ').$this->error());
        }

        function sql2var($sql) {
                if((empty($sql)) || (!($query = $this->query($sql)))) return false;
                return $this->result2var($query);
        }

        function result2var($q) {
                if(!($Data = $this->fetch_array($q))) return false;
                $this->free_result($q);
                foreach($Data as $k=>$v) $GLOBALS[$k] = $v;
                return true;
        }

        function sql2array($sql, $keyField='') {
                if((empty($sql)) || (!($query = $this->query($sql)))) return false;
                return $this->result2array($query, $keyField);
        }

        function result2array($q, $keyField='') {
                $Result = array();
                while($Data = $this->fetch_array($q))
                        if(empty($keyField)) $Result[] = $Data;
                        else $Result[$Data[$keyField]] = $Data;
                $this->free_result($q);
                return $Result;
        }

        function list_tables() {
                $tables = mysql_list_tables($this->db, $this->link);
                $Result = array();
                while($Data = mysql_fetch_row($tables))
                    if( isset($Data[0]) )
                        $Result[] = $Data[0];
                return $Result;
        }

        function list_fields($table_name, $named_index=false) {
                $fields = mysql_list_fields($this->db, $table_name, $this->link);
                $count = mysql_num_fields($fields);
                $Result = array();
                for ($i=0; $i<$count; $i++) {
                    $key = $named_index ? mysql_field_name($fields, $i) : $i;
                    $Result[$key]['type'] = mysql_field_type($fields, $i);
                    $Result[$key]['name'] = mysql_field_name($fields, $i);
                    $Result[$key]['len'] = mysql_field_len($fields, $i);
                    $Result[$key]['flags'] = mysql_field_flags($fields, $i);
                }
                return $Result;
        }
};
?>
