<?php

/**
* Detach proxies (IP and port) from content
* @param string $content
* @return array('host'=>'host', 'port'=>'port')
*/
function detach_proxies($content) {
	global $CONF;
	$prox = array();
	foreach($CONF['reg_exp'] as $pat)
		if(preg_match_all($pat,$content,$m,PREG_SET_ORDER))
			$prox = array_merge($prox, $m);
	return $prox;		
}

?>